VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Gerador de Grficos"
   ClientHeight    =   7875
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   9240
   LinkTopic       =   "Form1"
   ScaleHeight     =   7875
   ScaleWidth      =   9240
   StartUpPosition =   3  'Windows Default
   Begin VB.TextBox txtYmax 
      Height          =   285
      Left            =   6240
      TabIndex        =   5
      Text            =   "7"
      Top             =   240
      Width           =   615
   End
   Begin VB.TextBox txtYmin 
      Height          =   285
      Left            =   5520
      TabIndex        =   4
      Text            =   "-7"
      Top             =   240
      Width           =   615
   End
   Begin VB.PictureBox picGraph 
      AutoRedraw      =   -1  'True
      Height          =   7095
      Left            =   120
      ScaleHeight     =   7035
      ScaleWidth      =   8955
      TabIndex        =   11
      Top             =   720
      Width           =   9015
   End
   Begin VB.CommandButton cmdGraph 
      Caption         =   "Gerar Grfico"
      Default         =   -1  'True
      Height          =   375
      Left            =   7080
      TabIndex        =   10
      Top             =   120
      Width           =   1935
   End
   Begin VB.TextBox txtXmax 
      Height          =   285
      Left            =   3960
      TabIndex        =   2
      Text            =   "10"
      Top             =   240
      Width           =   615
   End
   Begin VB.TextBox txtXmin 
      Height          =   285
      Left            =   3240
      TabIndex        =   1
      Text            =   "-10"
      Top             =   240
      Width           =   615
   End
   Begin VB.TextBox txtDx 
      Height          =   285
      Left            =   4680
      TabIndex        =   3
      Text            =   ".1"
      Top             =   240
      Width           =   495
   End
   Begin VB.TextBox txtExpression 
      Height          =   285
      Left            =   120
      TabIndex        =   0
      Text            =   "10*sin(x*2)/(x*x+1)"
      Top             =   240
      Width           =   3015
   End
   Begin VB.Label Label1 
      Caption         =   "Y min"
      Height          =   255
      Index           =   4
      Left            =   5520
      TabIndex        =   13
      Top             =   0
      Width           =   615
   End
   Begin VB.Label Label1 
      Caption         =   "Y max"
      Height          =   255
      Index           =   2
      Left            =   6240
      TabIndex        =   12
      Top             =   0
      Width           =   615
   End
   Begin VB.Label Label1 
      Caption         =   "X min"
      Height          =   255
      Index           =   1
      Left            =   3240
      TabIndex        =   9
      Top             =   0
      Width           =   615
   End
   Begin VB.Label Label1 
      Caption         =   "X max"
      Height          =   255
      Index           =   3
      Left            =   3960
      TabIndex        =   8
      Top             =   0
      Width           =   615
   End
   Begin VB.Label Dx 
      Caption         =   "Dx"
      Height          =   255
      Index           =   2
      Left            =   4680
      TabIndex        =   7
      Top             =   0
      Width           =   495
   End
   Begin VB.Label Label1 
      Caption         =   "Expresso"
      Height          =   255
      Index           =   0
      Left            =   120
      TabIndex        =   6
      Top             =   0
      Width           =   975
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private m_Primatives As Collection

' Graph the equation entered by the user.
Private Sub cmdGraph_Click()
Dim expr As String
Dim xmin As Single
Dim xmax As Single
Dim Dx As Single
Dim ymin As Single
Dim ymax As Single
Dim x As Single
Dim y1 As Single
Dim y2 As Single
Dim i As Integer

    On Error GoTo EvaluateError

    ' Make the primatives collection.
    Set m_Primatives = New Collection

    ' Get the bounds.
    xmin = CSng(txtXmin.Text)
    xmax = CSng(txtXmax.Text)
    Dx = CSng(txtDx.Text)
    ymin = CSng(txtYmin.Text)
    ymax = CSng(txtYmax.Text)

    ' Scale to fit the bounds.
    picGraph.Scale (xmin, ymax)-(xmax, ymin)

    ' Get the expression.
    expr = txtExpression.Text

    ' Draw the graph's background.
    picGraph.Cls
    picGraph.Line (xmin, 0)-(xmax, 0), vbBlue
    picGraph.Line (0, ymin)-(0, ymax), vbBlue
    For i = 0 To xmin Step -1
        picGraph.Line (i, -0.25)-Step(0, 0.5), vbRed
    Next i
    For i = 0 To xmax
        picGraph.Line (i, -0.25)-Step(0, 0.5), vbRed
    Next i
    For i = 0 To ymin Step -1
        picGraph.Line (-0.25, i)-Step(0.5, 0), vbRed
    Next i
    For i = 0 To ymax
        picGraph.Line (-0.25, i)-Step(0.5, 0), vbRed
    Next i

    ' Graph the equation.
    m_Primatives.Add xmin, "x"
    y1 = EvaluateExpression(expr)
    For x = xmin + Dx To xmax Step Dx
        ' Set the new value for x.
        m_Primatives.Remove "x"
        m_Primatives.Add x, "x"

        ' Evaluate.
        y2 = EvaluateExpression(expr)

        ' Draw the next line.
        picGraph.Line (x - Dx, y1)-(x, y2)

        ' Save the current Y value.
        y1 = y2
    Next x
    Exit Sub

EvaluateError:
    Beep
    MsgBox Err.Description
End Sub
' Evaluate the expression.
Private Function EvaluateExpression(ByVal expression As String) As Double
Const PREC_NONE = 11
Const PREC_UNARY = 10   ' Not actually used.
Const PREC_POWER = 9
Const PREC_TIMES = 8
Const PREC_DIV = 7
Const PREC_INT_DIV = 6
Const PREC_MOD = 5
Const PREC_PLUS = 4

Dim expr As String
Dim is_unary As Boolean
Dim next_unary As Boolean
Dim parens As Integer
Dim pos As Integer
Dim expr_len As Integer
Dim ch As String
Dim lexpr As String
Dim rexpr As String
Dim value As String
Dim status As Long
Dim best_pos As Integer
Dim best_prec As Integer

    ' Remove all spaces.
    expr = Replace$(expression, " ", "")
    expr_len = Len(expr)
    If expr_len = 0 Then
        EvaluateExpression = 0
        Exit Function
    End If

    ' If we find + or - now, it is a unary operator.
    is_unary = True

    ' So far we have nothing.
    best_prec = PREC_NONE

    ' Find the operator with the lowest precedence.
    ' Look for places where there are no open
    ' parentheses.
    For pos = 1 To expr_len
        ' Examine the next character.
        ch = Mid$(expr, pos, 1)

        ' Assume we will not find an operator. In
        ' that case, the next operator will not
        ' be unary.
        next_unary = False

        If ch = " " Then
            ' Just skip spaces. We keep them here
            ' to make the error messages easier to
        ElseIf ch = "(" Then
            ' Increase the open parentheses count.
            parens = parens + 1

            ' A + or - after "(" is unary.
            next_unary = True
        ElseIf ch = ")" Then
            ' Decrease the open parentheses count.
            parens = parens - 1

            ' An operator after ")" is not unary.
            next_unary = False

            ' If parens < 0, too many ')'s.
            If parens < 0 Then
                Err.Raise vbObjectError + 1001, _
                    "EvaluateExpression", _
                    "Too many )s in '" & _
                    expression & "'"
            End If
        ElseIf parens = 0 Then
            ' See if this is an operator.
            If ch = "^" Or ch = "*" Or _
               ch = "/" Or ch = "\" Or _
               ch = "%" Or ch = "+" Or _
               ch = "-" _
            Then
                ' An operator after an operator
                ' is unary.
                next_unary = True

                ' See if this operator has higher
                ' precedence than the current one.
                Select Case ch
                    Case "^"
                        If best_prec >= PREC_POWER Then
                            best_prec = PREC_POWER
                            best_pos = pos
                        End If

                    Case "*", "/"
                        If best_prec >= PREC_TIMES Then
                            best_prec = PREC_TIMES
                            best_pos = pos
                        End If

                    Case "\"
                        If best_prec >= PREC_INT_DIV Then
                            best_prec = PREC_INT_DIV
                            best_pos = pos
                        End If

                    Case "%"
                        If best_prec >= PREC_MOD Then
                            best_prec = PREC_MOD
                            best_pos = pos
                        End If

                    Case "+", "-"
                        ' Ignore unary operators
                        ' for now.
                        If (Not is_unary) And _
                            best_prec >= PREC_PLUS _
                        Then
                            best_prec = PREC_PLUS
                            best_pos = pos
                        End If
                End Select
            End If
        End If
        is_unary = next_unary
    Next pos

    ' If the parentheses count is not zero,
    ' there's a ')' missing.
    If parens <> 0 Then
        Err.Raise vbObjectError + 1002, _
            "EvaluateExpression", "Missing ) in '" & _
            expression & "'"
    End If
    
    ' Hopefully we have the operator.
    If best_prec < PREC_NONE Then
        lexpr = Left$(expr, best_pos - 1)
        rexpr = Mid$(expr, best_pos + 1)
        Select Case Mid$(expr, best_pos, 1)
            Case "^"
                EvaluateExpression = _
                    EvaluateExpression(lexpr) ^ _
                    EvaluateExpression(rexpr)
            Case "*"
                EvaluateExpression = _
                    EvaluateExpression(lexpr) * _
                    EvaluateExpression(rexpr)
            Case "/"
                EvaluateExpression = _
                    EvaluateExpression(lexpr) / _
                    EvaluateExpression(rexpr)
            Case "\"
                EvaluateExpression = _
                    EvaluateExpression(lexpr) \ _
                    EvaluateExpression(rexpr)
            Case "%"
                EvaluateExpression = _
                    EvaluateExpression(lexpr) Mod _
                    EvaluateExpression(rexpr)
            Case "+"
                EvaluateExpression = _
                    EvaluateExpression(lexpr) + _
                    EvaluateExpression(rexpr)
            Case "-"
                EvaluateExpression = _
                    EvaluateExpression(lexpr) - _
                    EvaluateExpression(rexpr)
        End Select
        Exit Function
    End If

    ' If we do not yet have an operator, there
    ' are several possibilities:
    '
    ' 1. expr is (expr2) for some expr2.
    ' 2. expr is -expr2 or +expr2 for some expr2.
    ' 3. expr is Fun(expr2) for a function Fun.
    ' 4. expr is a primitive.
    ' 5. It's a literal like "3.14159".

    ' Look for (expr2).
    If Left$(expr, 1) = "(" And Right$(expr, 1) = ")" Then
        ' Remove the parentheses.
        EvaluateExpression = EvaluateExpression( _
            Mid$(expr, 2, expr_len - 2))
        Exit Function
    End If

    ' Look for -expr2.
    If Left$(expr, 1) = "-" Then
        EvaluateExpression = -EvaluateExpression( _
            Mid$(expr, 2))
        Exit Function
    End If

    ' Look for +expr2.
    If Left$(expr, 1) = "+" Then
        EvaluateExpression = EvaluateExpression( _
            Mid$(expr, 2))
        Exit Function
    End If
    
    ' Look for Fun(expr2).
    If expr_len > 5 And Right$(expr, 1) = ")" Then
        ' Find the first (.
        pos = InStr(expr, "(")

        If pos > 0 Then
            ' See what the function is.
            lexpr = LCase$(Left$(expr, pos - 1))
            rexpr = Mid$(expr, pos + 1, expr_len - pos - 1)
            Select Case lexpr
                Case "sin"
                    EvaluateExpression = Sin(EvaluateExpression(rexpr))
                    Exit Function
                Case "cos"
                    EvaluateExpression = Cos(EvaluateExpression(rexpr))
                    Exit Function
                Case "tan"
                    EvaluateExpression = Tan(EvaluateExpression(rexpr))
                    Exit Function
                Case "sqr"
                    EvaluateExpression = Sqr(EvaluateExpression(rexpr))
                    Exit Function
                Case "factorial"
                    EvaluateExpression = Factorial(EvaluateExpression(rexpr))
                    Exit Function
                ' Add other functions (including
                ' program-defined functions) here.
            End Select
        End If
    End If

    ' See if it's a primitive.
    On Error Resume Next
    value = m_Primatives.Item(expr)
    status = Err.Number
    On Error GoTo 0
    If status = 0 Then
        ' We found the primative.
        EvaluateExpression = CDbl(value)
        Exit Function
    End If

    ' It must be a literal like "2.71828".
    On Error Resume Next
    EvaluateExpression = CDbl(expr)
    status = Err.Number
    On Error GoTo 0
    If status <> 0 Then
        Err.Raise status, _
            "EvaluateExpression", _
            "Error evaluating '" & expression & _
            "' as a constant."
    End If
End Function
' Return the factorial of the expression.
Private Function Factorial(ByVal value As Double) As Double
Dim result As Double

    ' Make sure the value is an integer.
    If CLng(value) <> value Then
        Err.Raise vbObjectError + 1001, _
            "Factorial", _
            "Argument must be an integer in Factorial(" & _
            Format$(value) & ")"
    End If

    result = 1
    Do While value > 1
        result = result * value
        value = value - 1
    Loop
    Factorial = result
End Function

